# Add database adapter

Every database adapter is a separate package. To create a adapter for new database you need to create a new Dart package and the database adapter should extend `Adapter` class.

## Create package

Fork the repository and clone it to your local machine. Then create a new Dart package using the following command.

The naming pattern for the database adapter package is `utopia_database_adapter_<database_name>`. For example, the MariaDB adapter package is `utopia_database_adapter_mariadb`.

```bash
dart create -t package utopia_database_adapter_<database_name>
```

## Add dependencies

```yaml
dependencies:
  utopia_database: <latest>
```

## Create adapter

Create a new Dart file in the `lib` directory and extend the `Adapter` class.

```dart
import 'package:utopia_database/utopia_database.dart';

class <DatabaseName> extends Adapter {
    // implement the abstract methods
}
```
